【leetcode】11. Container With Most Water

230 篇文章 0 订阅

11. Container With Most Water

Medium

Given n non-negative integers a1a2, ..., an , where each represents a point at coordinate (iai). n vertical lines are drawn such that the two endpoints of line i is at (iai) and (i, 0). Find two lines, which together with x-axis forms a container, such that the container contains the most water.

Note: You may not slant the container and n is at least 2.

 

The above vertical lines are represented by array [1,8,6,2,5,4,8,3,7]. In this case, the max area of water (blue section) the container can contain is 49.

 

Example:

Input: [1,8,6,2,5,4,8,3,7]
Output: 49

题目链接:https://leetcode.com/problems/container-with-most-water/

 

解题思路:

原本按照算法树的思路,想从动态规划入手,从后往前找满足所需宽度距和高度要求的木板,企图从暴力的O(n^2)尽量向O(n)靠,但没能找到限制向前查找的停止条件。

后来看了solution才恍然大悟用双指针竟然如此简单。

 

方法:双指针向中间夹逼 O(n)

这里有一条规律:组成最大容积的两块板l和r,l的左边没有高度大等于l的板,r右边没有高度大等于r的板。这个规律很容易用数学式子证明。因此可以用双指针夹逼,从宽最大的情况,向中间找时,以高度换宽度。

具体步骤:两个指针从两头向中间靠拢,同时更新最大容积;在收缩区间的时候优先从中较小的边开始收缩。

代码:

class Solution {
public:
    int maxArea(vector<int>& height) {
        int l = 0, r = height.size() - 1, maxval = 0;
        while (l < r){
            maxval = max(maxval, min(height[l], height[r]) * (r - l));
            (height[l] <= height[r])? l++: r--;
        }
        return maxval;
    }
};

 

一个小总结:

对找区间的题,可以考虑用双指针。双指针有从同一起点出发,有两边向中间夹逼。

 

本篇参考:https://blog.csdn.net/a83610312/article/details/8548519

http://www.cnblogs.com/grandyang/p/4455109.html

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值